#	include	"mosslib.h"
#	include	"aplib.h"

#	include	<signal.h>

ActivePageMemorySystem	*APMS = NULL;

int	ActivePage	::	VLIWWidth	=	4;

int	__global_APMS(
	int	usec,
	ActivePage	*ap)
	{

	if(!ap)
		{
		if(APMS)
			return(APMS->SimulateFor(usec));
		else
			return(0);
		}
	else
		{
		if(APMS->isLocked)
			return(0);	// give it to someone else if locked
		int	ret;
		ap->IsNowActive = 1;
		ret = ap->SimulateFor(usec);
		ap->IsNowActive = 0;
		return(ret);
		}

	return(0);
	}

int
main(
	int	argc,
	char	*argv[],
	char	*env[])
	{
	int	i;

	/* this is unfortuant, but signals are not accuretly accounted for
	 * or are rather slew-rated against the pump value, which we don't want.
	 * Somewhere in the C++ stdc++ library a signal handler is setup for
	 * something, and I'm not sure what.  We don't want this, since it
	 * is a Bad Thing (tm).  Anyway, we just kill all the handlers.
	 * maybe some day I should find out exactly which one and why, but
	 * for now, I don't care.  Just kill um all and pray god sorts it out...
	 */
	i = 0;
	while(i<64)
		{
		signal(i, SIG_IGN);
		++i;
		}	
	APLibStart();
	char	*sched = getenv("APMUL");
	if(!sched)
		APMS->APMultiplexer = 1;
	else
		APMS->APMultiplexer = atoi(sched)%32;
	char	*width = getenv("APWIDTH");
	if(!width)
		ActivePage::VLIWWidth = 4;
	else
		ActivePage::VLIWWidth = atoi(width);

	printf("Setting APMS Multiplexing to %d and width to %d\n",
		APMS->APMultiplexer, ActivePage::VLIWWidth);
	i=apmain(argc,argv);
	//printf("Calling APLibEnd...\n");fflush(stdout);
	APLibEnd();
	//printf("Calling exit()...\n");fflush(stdout);
	exit(i);
	}

int
APLibStart()
	{
	APMS = new ActivePageMemorySystem;
#ifdef	MOSS_DEV
	pump_up_the_volume(1, 1, 1);
#else
	// Note, as of mid Feburary, volume is pumped up system-wide
	// so don't modify it on each application run!
	//pump_up_the_volume(1, 100);
#endif
	install_sim_thread(__global_APMS, NULL);
	}
int
APLibEnd()
	{
	// unregister all pages
	ActivePage	*ap1 = APMS->APList;

	while(ap1)
		{
#ifndef	MOSS_DEV
		unregister_page(ap1);
#endif
		ap1 = ap1->Next;
		}


#ifdef	MOSS_DEV
	pump_up_the_volume(0,0, 0);
#else
//	pump_up_the_volume(0,0);
	//printf("About to dis-engage thread...\n");fflush(stdout);
	install_sim_thread(NULL, NULL);
	//printf("Thread dis-engaged...\n");fflush(stdout);
#endif
	/* delete APMS */
	}

int
ActivePage	::	SimulateFor(
	int		usec)
	{
	moss_printf(
"probable error: ActivePage :: SimulateFor(%d) -- Base Activated\n", usec);
	return(-1);
	}

ActivePageMemorySystem	::	ActivePageMemorySystem()
	{
	APList = NULL;
	isLocked = 0;
	qsec = 0;
	APMultiplexer = 1;
	APStart = 0;
	}

ActivePageMemorySystem	::	~ActivePageMemorySystem()
	{
	/*pump_up_the_volume(0,0);*/
	}

int
ActivePageMemorySystem	::	Add(
	ActivePage	*ap)
	{
	isLocked = 1;
	ap->Next = APList;	
	APList = ap;
	isLocked = 0;
#ifndef	MOSS_DEV
	register_page(ap);
#endif
	return(0);
	}

int
ActivePageMemorySystem	::	Remove(
	ActivePage	*ap)
	{
	ActivePage	*ap1 = APList, *ap2;

	//printf("Removing...\n");fflush(stdout);
	if(!ap1) return(-1);
#ifndef	MOSS_DEV
	if(ap)
		unregister_page(ap);
#endif
	//printf("Unregistered...\n");fflush(stdout);

	isLocked = 1;
	ap2 = NULL;
	while(ap1 != ap)	
		{
		ap2 = ap1;
		ap1 = ap1->Next;
		if(!ap1) { isLocked = 0; return(-1); }
		}
	if(ap2)
		{
		ap2->Next = ap1->Next;
		}
	else
		{
		APList = ap1->Next;
		}
	//printf("Removed...\n");fflush(stdout);
	isLocked = 0;
	return(0);
	}

int
ActivePageMemorySystem	::	SimulateFor(
	int		usec)
	{
	ActivePage	*ap1 = APList;
	ActivePage	*aplist[32];	// assume no more than 32 for a mul
	if(isLocked)
		{
		qsec += usec;
		return(0);
		}
	usec += qsec;
	/* o.k., multiplexing is done by "asking" a page whether or not
	 * it consumed a time-slice.  If it did, then we move on to the next
	 * stride set
	 */
	int		Position, Index, Size, TimeLeft;
	if(APStart >= APMultiplexer)
		APStart = 0;
	while(ap1)
		{
		Index = 0;
		while(ap1)
			{
			if(Index>=APMultiplexer)
				break;
			aplist[Index] = ap1;
			ap1 = ap1->Next;
			++Index;
			}
		// o.k., now, activate one of these within the set.
		Size = Index;
		Position = APStart % Index;
		Index = Position;
		TimeLeft = usec;
		aplist[Position]->IsNowActive = 1;
		TimeLeft -= aplist[Position]->SimulateFor(TimeLeft);
		aplist[Position]->IsNowActive = 0;
		++Position;if(Position >= Size) Position = 0;
		while(Position!=Index)
			{	
			if(TimeLeft <= 0)
				break;
			aplist[Position]->IsNowActive = 1;
			TimeLeft -= aplist[Position]->SimulateFor(TimeLeft);
			aplist[Position]->IsNowActive = 0;
			++Position;if(Position >= Size) Position = 0;
			}
		}
	qsec = 0;
	++APStart;
	return(0);
	}

